import { Guard } from "./guard";
import { RelationType } from "./parse";
import { Primitive, RSE } from "./utils";
import { Valit } from "./valit";
declare global {
    namespace vality {
        interface guards {
            string: Guard<string, {
                minLength: number;
                maxLength: number;
                match: RegExp;
            }>;
            number: Guard<number, {
                min: number;
                max: number;
                /**
                 * Whether the number has to be an integer
                 */
                integer: boolean;
            }>;
            boolean: Guard<boolean>;
            date: Guard<Date, {
                min: Date;
                max: Date;
                /**
                 * Whether the date must lie in the past
                 */
                past: boolean;
                /**
                 * Whether the date must lie in the future
                 */
                future: boolean;
            }>;
            /**
             * @example vality.literal(7)
             */
            literal(lit: Primitive): Guard<typeof lit>;
            /**
             * @example vality.relation(SomeModel)
             */
            relation<S extends () => RSE>(type: S): Valit<S, {
                transform: (v: RelationType) => RelationType;
            }>;
        }
    }
}
