import { Eny, RSE } from "./utils";
import { ReadonlyValit, Valit } from "./valit";
declare global {
    namespace vality {
        interface valits {
            array: <E extends Eny>(e: E) => Valit<E[], {
                minLength: number;
                maxLength: number;
                /**
                 * Whether to stop validating after the first error
                 *
                 * @default false
                 */
                bail: boolean;
            }>;
            tuple: <E extends Eny[]>(...es: E) => Valit<E, {
                /**
                 * @default false
                 */
                bail: boolean;
            }>;
            optional: <E extends Eny>(e: E) => Valit<undefined | E>;
            enum: <E extends Eny[]>(...es: E) => Valit<E[number]>;
            object: <E extends RSE>(v: E) => Valit<E, {
                /**
                 * Whether to stop validating after the first error
                 *
                 * @default false
                 */
                bail?: boolean;
            }>;
            /**
             * This valit wraps the passed eny so that it is ignored by ParseIn
             */
            readonly: <E extends Eny>(e: E) => ReadonlyValit<E>;
        }
    }
}
